/*
 *		ԃR[h
 *
 *		T.Kobayashi		1994.5.21
 */

#define	CODE	1

#ifndef	DATA
	#include "data.h"
#endif

/*
 *	\R[h
 */
#define		CODE_CONST		1		/*	萔	*/
#define		CODE_OPERATOR	2		/*	Zq	*/
#define		CODE_SENTENSE	3		/*			*/
#define		CODE_IDENT		4		/*	ʎq	*/
#define		CODE_ARRAY		5		/*	z	*/

/*		*/
#define		SENT_VAR		1		/*	ϐ`	*/
#define		SENT_DEF_FUNC	2		/*	֐`	*/
#define		SENT_IF			11		/*	if 		*/
#define		SENT_IF_ELSE	12		/*	if-else 	*/
#define		SENT_WHILE		13		/*	while 	*/
#define		SENT_DO			14		/*	do-while 	*/
#define		SENT_FOR		15		/*	for 		*/
#define		SENT_BREAK		16		/*	break 	*/
#define		SENT_CONTINUE	17		/*	continue 	*/
#define		SENT_RETURN		18		/*	return 	*/
#define		SENT_NULL		20		/*			*/
#define		SENT_COMPLEX	21		/*			*/
#define		SENT_ASSIGN		22		/*			*/
#define		SENT_ASN_PLUS	23		/*	+=			*/
#define		SENT_ASN_MINUS	24		/*	-=			*/
#define		SENT_ASN_MULT	25		/*	*=			*/
#define		SENT_ASN_DIVIDE	26		/*	/=			*/
#define		SENT_ASN_AND	27		/*	&=			*/
#define		SENT_ASN_OR		28		/*	|=			*/
#define		SENT_ASN_XOR	29		/*	|=			*/
#define		SENT_ASN_INC	30		/*	++			*/
#define		SENT_ASN_DEC	31		/*	--			*/
#define		SENT_EXPRESS	32		/*				*/

/*
 *		\\
 */
/*	ʕ	*/
typedef	struct	{
	char	type, size ;
}
	CodeCommon ;

/*	萔	*/
typedef	struct	{
	char		type, size ;
	DataStruct	data ;
}
	CodeConst ;

/*	Zq	*/
typedef	struct	{
	char	type, size ;
	short	otype ;		/*	Zq̎		*/
}
	CodeOperator ;

/*		*/
typedef	struct	{
	char	type, size ;
	short	stype ;		/*	̎				*/
	short	line ;		/*	݂̑sԍ		*/
	char	*file ;		/*	݂̑t@C	*/
	void	*next ;		/*	̕ւ̃|C^		*/
}
	CodeSentense ;

/*	ʎq	*/
typedef	struct	{
	char	type, size ;
	short	itype ;		/*	ʎq̎	*/
	short	ident ;		/*	ʎqԍ		*/
}
	CodeIdent ;

/*	z	*/
typedef	struct	{
	char	type, size ;
	short	asize ;		/*	ʎq̎	*/
}
	CodeArray ;

typedef	union	{
	char			type ;
	CodeCommon		com ;
	CodeConst		c ;
	CodeOperator	ope ;
	CodeSentense	sent ;
	CodeIdent		ident ;
	CodeArray		ary ;
}
	CodeStruct ;

/*	code.c	*/
extern	void	CodeInit( int );
extern	void	CodeExit( void );
extern	CodeConst	*CodeSetInt( int );
extern	CodeConst	*CodeSetConst( DataStruct* );
extern	CodeOperator	*CodeSetOperator( int );
extern	CodeSentense	*CodeSetSentense( char*, int );
extern	CodeIdent	*CodeSetIdent( int, int );
extern	CodeArray	*CodeSetArray( int );
extern	CodeStruct	*CodeTop( void );
extern	CodeStruct	*CodeNextPtr( void );
extern	CodeStruct	*CodeNext( CodeStruct* );
extern	CodeStruct	*CodeNextSentense( CodeStruct* );
extern	void	*CodeAlloc( int );
